﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
#IgnoreWarnings:12, 9
Sub Process_Globals
	'this is the name of the page
	Public name As String = "home"
	'what is the title of the page
	Public title As String = "Home"
	'what is the icon of the page
	Public icon As String = "fa-solid fa-house"
	'this variable holds the page controller
	Public page As SDUIPage
	'this variable holds reference to the app
	'usually for constants and other things
	Public app As SDUIApp
	'the variable referencing banano lib
	Private banano As BANano		'ignore
	Public Form As SDUIForm			'ignore
	Private btnGoogleAuth As SDUIButton		'ignore
	Private btnSignOut As SDUIButton		'ignore
	Private pb As SDUIPocketBase			'ignore
	Private lblUserName As SDUILabel		'ignore
	Private lblName As SDUILabel			'ignore
	Private avtUser As SDUIAvatar			'ignore
	Private lblEmail As SDUILabel			'ignore
	Private lblToken As SDUILabel			'ignore
	Private lblid As SDUILabel				'ignore
End Sub

'** DO NOT DELETE
'sub to show the page
Sub Show(duiapp As SDUIApp)			'ignore
	'get the reference to the app
	app = duiapp
	'build the page, via code or loadlayouts
	BuildPage
	app.PageResume
End Sub

'** DO NOT DELETE
'sub to get the name of the page
Sub getName As String
	Return name
End Sub

'** DO NOT DELETE
'sub to get the icon of the page
Sub getIcon As String
	Return icon
End Sub

'** DO NOT DELETE
'sub to get the title of the page
Sub getTitle As String
	Return title
End Sub

'** DO NOT DELETE
'start building the page, here you load layouts / code your app
private Sub BuildPage
	pb.Initialize(Me, "pb", "http://127.0.0.1:8010", "users")
	'load the page layout
	banano.LoadLayout(app.PageViewer, "homelayout")
	'start adding you components here
	Form.Initialize(Me, name, name)
	Form.LinkExisting
	'
	
	Form.AddComponentLabel("1", "1", "lblid", "ID:", "")
	Form.AddComponentLabel("1", "2", "lblusername", "User Name:", "")
	Form.AddComponentLabel("2", "1", "lblname", "Name:", "")
	Form.AddComponentLabel("2", "2", "lblemail", "Email:", "")
	Form.AddComponentAvatar("3", "1", "avtuser", app.SDLogo, "60px", app.MASK_SQUIRCLE)
	Form.AddComponentLabel("3", "2", "lbltoken", "Token:", "")
	
	Form.AddComponentButton("4", "1", "btnSignOut", "Sign Out", "error", "white", False, True, False)
	Form.AddComponentButton("4", "2", "btngoogleauth", "Google Auth", "success", "white", False, True, False)
	banano.Await(Form.BuildForm(False))
	'
	'assign the components
	btnGoogleAuth = Form.Component("btngoogleauth")
	lblUserName = Form.Component("lblusername")
	lblName = Form.Component("lblname")
	avtUser = Form.Component("avtuser")
	lblEmail = Form.Component("lblemail")
	lblToken = Form.Component("lbltoken")
	lblid = Form.Component("lblid")
End Sub

Private Sub btnSignOut_Click (e As BANanoEvent)
	e.preventdefault
	'clear the auth store
	pb.USER_SIGNOUT
End Sub


Private Sub btnGoogleAuth_Click (e As BANanoEvent)
	e.preventdefault
	btnGoogleAuth.Loading = True
	Dim profile As profileType = banano.Await(pb.USER_AUTH_WITH_GOOGLE)
	btnGoogleAuth.Loading = False
	If pb.IsAuthenticated = False Then
		app.ShowToastError("The user could not be authenticated!", 3000)
		lblUserName.Caption = "User Name:"
		lblName.Caption = "Name:"
		lblEmail.Caption = "Email:"
		lblToken.Caption = "Token:"
		avtUser.Src = app.SDLogo
	Else
		app.ShowToastSuccess("The user has been authenticated!", 3000)
		lblUserName.Caption = "User Name: " & profile.UserName
		lblName.Caption = "Name: " & profile.name
		lblEmail.Caption = "Email: " & profile.email
		lblToken.Caption = "Token: " & SDUIShared.Left1(profile.token,5) & "..."
		avtUser.Src = profile.avatar
	End If
	
End Sub